/*!
	IFilter

	tB^ׂ̎C^tF[X
*/

#pragma once
#include "IServerTool.h"
#include "IConnectionControl.h"
#include "Context.h"

class IFilter;
class IFilterContext;

//!	C^[tF[X`
DEFINE_INTERNAL_INTERFACE(IFilter);
DEFINE_INTERNAL_INTERFACE_NOWRAP(IFilterContext);

/*!
	tB^ReLXg
*/
class IFilterContext
{
public:
	virtual ~IFilterContext() {};

	//!	C^tF[X擾
	virtual IFilterContextIIPtr GetIFilterContext() = 0;

	//!	T[oc[擾
	virtual IServerToolIIPtr GetIServerTool() = 0;

	//!	XbhXe[^X擾
	virtual IConnectionThreadStatusIIPtr GetIConnectionThreadStatus() = 0;

	//!	ڑ擾
	virtual IConnectionControlIIPtr GetIConnectionControl() = 0;
		
	//!	ReLXg擾
	virtual CContext GetContxet() = 0;
};


/*!
	tB^
*/
class IFilter
{
public:
	virtual ~IFilter(void)
	{
	}

	//////////////////////////////////////////////////////////////////////////////////////////////
	//	
	//////////////////////////////////////////////////////////////////////////////////////////////
	//!	(OցI)
	virtual void Start(IFilterContextIIPtr filterContext) = 0;

	//!	tB^擾
	virtual LPCTSTR GetFilterName() = 0;

	//////////////////////////////////////////////////////////////////////////////////////////////
	//	NGXgM
	//////////////////////////////////////////////////////////////////////////////////////////////
	//!	NGXgwb_
	virtual void FilterRequestHeader(IFilterContextIIPtr filterContext, CContextRequestInfo &requestInfo) = 0;

	//!	{fBMAJԂ(throw)
	virtual void FilterRequestBody(IFilterContextIIPtr filterContext, CBinaryData &body) = 0;

	//!	M
	virtual void FilterEndRequest(IFilterContextIIPtr filterContext) = 0;


	//////////////////////////////////////////////////////////////////////////////////////////////
	//	X|X
	//////////////////////////////////////////////////////////////////////////////////////////////
	//!	X|X
	virtual void FilterBuildResponse(IFilterContextIIPtr filterContext) = 0;

	//////////////////////////////////////////////////////////////////////////////////////////////
	//	X|XM
	//////////////////////////////////////////////////////////////////////////////////////////////
	//!	X|Xwb_
	virtual void FilterResponseHeader(IFilterContextIIPtr filterContext, CContextResponseInfo &responseInfo) = 0;

	//!	{fB𑗐MAJԂ(throw)
	virtual void FilterResponseBody(IFilterContextIIPtr filterContext, CBinaryData &body) = 0;

	//!	M
	virtual void FilterEndResponse(IFilterContextIIPtr filterContext) = 0;

	//////////////////////////////////////////////////////////////////////////////////////////////
	//	T[oX|XM(O)
	//////////////////////////////////////////////////////////////////////////////////////////////
	//!	X|Xwb_(OցI)
	virtual void FilterServerResponse(IFilterContextIIPtr filterContext, CContextResponseInfo &responseInfo, CBinaryData &body) = 0;

	//////////////////////////////////////////////////////////////////////////////////////////////
	//	~
	//////////////////////////////////////////////////////////////////////////////////////////////
	//!	ؒf(OցI)
	virtual void Stop(IFilterContextIIPtr filterContext) = 0;
};


/*!
	tB^NX
*/
class IFilterFactory
{
public:
	virtual ~IFilterFactory(void){}

	//////////////////////////////////////////////////////////////////////////////////////////////
	//	
	//////////////////////////////////////////////////////////////////////////////////////////////
	//!	
	virtual void StartFactory(IServerToolIIPtr serverTool) = 0;


	//!	~
	virtual void StopFactory() = 0;

	//////////////////////////////////////////////////////////////////////////////////////////////
	//	擾
	//////////////////////////////////////////////////////////////////////////////////////////////
	//!	tB^擾
	virtual IFilterIIPtr GetFilter() = 0;
};

//!	C^[tF[X`
DEFINE_INTERNAL_INTERFACE(IFilterFactory);

