#pragma once
#include "IResponse.h"
#include "IServerTool.h"
#include "Context.h"
#include "SyncObject.h"

class CResponseFactoryArray : public CArray<IResponseFactoryIIPtr> {};


/*!
	X|XǗ
*/
class IResponseManager
{
public:
	virtual ~IResponseManager(void) {};

	//!	X|X
	virtual IResponseIIPtr GetResponse(CContext context) = 0;
};

//!	C^tF[X
DEFINE_INTERNAL_INTERFACE_NOWRAP(IResponseManager);


/*!
	X|XǗ
*/
class CResponseManager : public IResponseManager
{
public:
	CResponseManager(void);
	virtual ~CResponseManager(void);

	///////////////////////////////////////////////////////////////////////////////////////////////////
	//	
	///////////////////////////////////////////////////////////////////////////////////////////////////
	//!	Jn
	void Start(IServerToolIIPtr serverTool);

	//!	~
	void Stop();

	///////////////////////////////////////////////////////////////////////////////////////////////////
	//	IResponseManager
	///////////////////////////////////////////////////////////////////////////////////////////////////
	//!	C^[tF[X擾
	IResponseManagerIIPtr GetIResponseManager() { return IResponseManagerRet(this, FALSE); };

	//!	X|X
	IResponseIIPtr GetResponse(CContext context);

protected:
	//////////////////////////////////////////////////////////////////////////////////////////////
	//	oϐ
	//////////////////////////////////////////////////////////////////////////////////////////////
	//!	tO
	CInterlockCounter		m_init;

	//!	NeBJZNV
	CCriticalSection		m_scopeLock;

	//!	T[oc[
	IServerToolIIPtr			m_serverTool;

	//!	t@Ng
	CResponseFactoryArray	m_responseFactorys;
};
