#pragma once

#include "FilterManager.h"

class CFilterControl : protected IFilterContext
{
public:
	CFilterControl(void);
	virtual ~CFilterControl(void);

	//////////////////////////////////////////////////////////////////////////////////////////////
	//	
	//////////////////////////////////////////////////////////////////////////////////////////////
	//!	
	void AttachFilters(IServerToolPtr serverTool, IConnectionThreadStatusPtr threadStatus, IConnectionControlPtr connectionControl, CContext &context);

	//!	I
	void DetachFilters();

	//////////////////////////////////////////////////////////////////////////////////////////////
	//	tB^
	//////////////////////////////////////////////////////////////////////////////////////////////
	//!	NGXgwb_
	void FilterRequestHeader();

	//!	{fBMAJԂ(throw)
	void FilterRequestBody(CBinaryData &body);

	//!	M
	void FilterEndRequest();

	//!	X|X
	void FilterBuildResponse();

	//!	X|Xwb_
	void FilterResponseHeader();

	//!	{fB𑗐MAJԂ(throw)
	void FilterResponseBody(CBinaryData &body);

	//!	M
	void FilterEndResponse();

	//!	X|Xwb_(OցI)
	void FilterServerResponse(CBinaryData &body);

protected:
	//////////////////////////////////////////////////////////////////////////////////////////////
	//	IFilterContext
	//////////////////////////////////////////////////////////////////////////////////////////////
	//!	C^tF[X擾
	virtual IFilterContextPtr GetIFilterContext()  { return IFilterContextRet(this, FALSE); };

	//!	T[oc[擾
	virtual IServerToolPtr GetIServerTool() { return m_serverTool->GetIServerTool(); };

	//!	XbhXe[^X擾
	virtual IConnectionThreadStatusPtr GetIConnectionThreadStatus() { return m_threadStatus->GetIConnectionThreadStatus(); };

	//!	ڑ擾
	virtual IConnectionControlPtr GetIConnectionControl() { return m_connectionControl->GetIConnectionControl(); };
		
	//!	ReLXg擾
	virtual CContext GetContxet() { return m_context; };

	//////////////////////////////////////////////////////////////////////////////////////////////
	//	oϐ
	//////////////////////////////////////////////////////////////////////////////////////////////
	//!	T[oc[
	IServerToolPtr				m_serverTool;

	//!	XbhXe[^X
	IConnectionThreadStatusPtr	m_threadStatus;

	//!	ڑRg[
	IConnectionControlPtr		m_connectionControl;

	//!	ReLXg
	CContext					m_context;

	//!	tB^z
	CFilterArray				m_filters;
};
