#include "StdAfx.h"
#include "KeepAliveFilter.h"
#include "ServerException.h"
#include "TextTools.h"

//!	W[
static TCHAR _MODULE_NAME[] = _T("KeepAliveFilter");

CKeepAliveFilter::CKeepAliveFilter(void)
{
}

CKeepAliveFilter::~CKeepAliveFilter(void)
{
}



/*!
	tB^擾
*/
LPCTSTR CKeepAliveFilter::GetFilterName()
{
	return _MODULE_NAME;
};

/*!
	
*/
void CKeepAliveFilter::StartFactory(IServerToolPtr serverTool)
{
	//	ς݁H
	if(m_init)
		return;
	m_init = TRUE;

	//	Rs[A
	m_serverTool = serverTool;

	//	ݒ擾
	m_setting = m_serverTool->GetFilterSetting(m_setting.GetSettingName());
	m_enableKeepAlive = m_setting.GetEnableKeepAlive();
	m_keepAliveTime = m_setting.GetMaxKeepConnectionTime();
	m_keepAliveCount = m_setting.GetMaxKeepConnectionCount();
}


/*!
	~
*/
void CKeepAliveFilter::StopFactory()
{
	//	`FbN
	if(!m_init)
		return;
	m_init = FALSE;
}



//////////////////////////////////////////////////////////////////////////////////////////////
//	NGXgM
//////////////////////////////////////////////////////////////////////////////////////////////
/*!
	NGXgwb_
*/
void CKeepAliveFilter::FilterRequestHeader(IFilterContextPtr filterContext, CContextRequestInfo &requestInfo)
{
	//	NGXgIvV擾
	CContextRequestOption	requestOption = requestInfo.GetRequestOption();

	//	KeepAlivewH
	if(m_enableKeepAlive && requestOption.GetConnection().CompareNoCase("keep-alive") == 0)
		filterContext->GetIConnectionControl()->SetReuseConnection(TRUE);
	else
		filterContext->GetIConnectionControl()->SetReuseConnection(FALSE);
}



//////////////////////////////////////////////////////////////////////////////////////////////
//	X|XM
//////////////////////////////////////////////////////////////////////////////////////////////
/*!
	X|Xwb_
*/
void CKeepAliveFilter::FilterResponseHeader(IFilterContextPtr filterContext, CContextResponseInfo &responseInfo)
{
	//	X|XIvV擾
	CContextResponseOption	responseOption = responseInfo.GetResponseOption();

	//	KeepAlive\H
	if(filterContext->GetIConnectionControl()->CanReuseConnection())
	{
		responseOption.SetConnection("Keep-Alive");
		responseOption.SetKeepAlive(CTextTools::GetFormat("timeout=%d, max=%d", m_keepAliveTime / 1000, m_keepAliveCount));
	}
	else
	{
		responseOption.SetConnection("Close");
		responseOption.ClearKeepAlive();
	}
}


