#pragma once

#include "IServerTool.h"
#include "Settings.h"
#include "SyncObject.h"
#include "IPathManager.h"


/*!
	pX}l[W
*/
class CPathManager : public IPathManager
{
public:
	CPathManager(void);
	virtual ~CPathManager(void);

	///////////////////////////////////////////////////////////////////////////////////////////////////
	//	
	///////////////////////////////////////////////////////////////////////////////////////////////////
	//!	Jn
	void Start(IServerToolPtr serverTool);

	//!	~
	void Stop();

	///////////////////////////////////////////////////////////////////////////////////////////////////
	//	C^[tF[X擾
	///////////////////////////////////////////////////////////////////////////////////////////////////
	//!	IPathTool擾
	IPathManagerPtr GetIPathManager() { return IPathManagerRet(this, FALSE); };

protected:
	///////////////////////////////////////////////////////////////////////////////////////////
	//	C^[tF[X
	///////////////////////////////////////////////////////////////////////////////////////////
	//!	pX
	virtual int FindPath(CString path, CString host, CPathInfo pathInfo);

	//!	pX擾
	virtual int GetPathCount();

	//!	CfbNXpX擾
	virtual int GetPathByIndex(int index, CPathInfo pathInfo);

	///////////////////////////////////////////////////////////////////////////////////////////////////
	//	oϐ
	///////////////////////////////////////////////////////////////////////////////////////////////////
	//!	NeBJZNV
	CCriticalSection					m_scopeLock;

	//!	tO
	CInterlockCounter					m_init;

	//!	IServerTool
	IServerToolPtr						m_serverTool;

	//!	pXݒ
	CPathManagerSetting					m_pathSetting;

	//!	pXXg
	CPathInfoList						m_pathList;

	//!	pXCfbNX
	CStringArray						m_pathIndex;

	//!	pXCfbNX()
	CArray<int>							m_pathIndexLen;

	//!	o[`zXgCfbNX
	CStringArray						m_hostIndex;

	//!	o[`zXg
	int									m_enableVirtualHost;
};
