#pragma once
#include "IResponse.h"
#include "IServerTool.h"
#include "Context.h"
#include "SyncObject.h"

class CResponseFactoryArray : public CArray<IResponseFactoryPtr> {};


/*!
	X|XǗ
*/
class IResponseManager
{
public:
	virtual ~IResponseManager(void) {};

	//!	X|X
	virtual IResponsePtr GetResponse(CContext context) = 0;
};

//!	C^tF[X
DEFINE_INTERFACE_NOWRAP(IResponseManager);


/*!
	X|XǗ
*/
class CResponseManager : public IResponseManager
{
public:
	CResponseManager(void);
	virtual ~CResponseManager(void);

	///////////////////////////////////////////////////////////////////////////////////////////////////
	//	
	///////////////////////////////////////////////////////////////////////////////////////////////////
	//!	Jn
	void Start(IServerToolPtr serverTool);

	//!	~
	void Stop();

	///////////////////////////////////////////////////////////////////////////////////////////////////
	//	IResponseManager
	///////////////////////////////////////////////////////////////////////////////////////////////////
	//!	C^[tF[X擾
	IResponseManagerPtr GetIResponseManager() { return IResponseManagerRet(this, FALSE); };

	//!	X|X
	IResponsePtr GetResponse(CContext context);

protected:
	//////////////////////////////////////////////////////////////////////////////////////////////
	//	oϐ
	//////////////////////////////////////////////////////////////////////////////////////////////
	//!	tO
	CInterlockCounter		m_init;

	//!	NeBJZNV
	CCriticalSection		m_scopeLock;

	//!	T[oc[
	IServerToolPtr			m_serverTool;

	//!	t@Ng
	CResponseFactoryArray	m_responseFactorys;
};
